#include <stdlib.h>
#include <stdio.h>
#include "myString.h"

static void reallocString(MyString* str);

MyString newString(unsigned int init_capacity){
	MyString str;
	str.arr = (char*) malloc(init_capacity);
	str.len = 0;
	str.capacity = init_capacity;
	return str;
}
void addCharToString(MyString* str, char c){
	if(str->len >= str->capacity){
		reallocString(str);
	}
	(str->arr)[str->len] = c;
	(str->len)++;
}

void freeString(MyString* str){
	free(str->arr);
	str->len = 0;
	str->capacity = 0;
	str->arr = NULL;
	str = NULL;
}

static void reallocString(MyString* str){
	str->arr = realloc(str->arr, (str->capacity)*2);
	(str->capacity)*=2;
	if(str->arr==0){
		printf("Нет памяти для строки 0x%lX", (unsigned long) str);
		exit(1);
	}
}
